// CategorySelectorItem.as
// John Maloney, August 2009
//
// A CategorySelectorItem is a text button for a named category in a CategorySelector.
// It handles mouse over, out, and up events and changes its appearance when selected.

package {
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import mx.core.UIComponent;

public class CategorySelectorItem extends UIComponent {

	public var categoryID:int;
	public var label:TextField;
	public var isSelected:Boolean = false;

	private static var normalColor:int = 0;
	private static var selectedColor:int = 0xE0E000;
	private static var highlightColor:int = 0xE0E0E0;

	public function CategorySelectorItem(id: int, s:String) {
		categoryID = id;
		initLabel(s);
		addEventListener(MouseEvent.MOUSE_OVER, mouseOver);
		addEventListener(MouseEvent.MOUSE_OUT, mouseOut);
		addEventListener(MouseEvent.MOUSE_UP, mouseUp);
	}

	private function initLabel(s:String):void {
		var format:TextFormat = new TextFormat();
		format.font = "Verdana";
		format.size = 14;

		label = new TextField();
		label.autoSize = TextFieldAutoSize.LEFT;
		label.selectable = false;
		label.background = false;
		label.text = s;
		label.setTextFormat(format);
		addChild(label);
		width = label.textWidth;
		height = label.textHeight;
		scaleX = scaleY = 1;
	}

	public function setSelected(flag:Boolean):void {
		isSelected = flag;
		label.textColor = isSelected ? selectedColor : normalColor;
	}

	private function mouseOver(event:MouseEvent):void {
		label.textColor = highlightColor;
	}

	private function mouseOut(event:MouseEvent):void {
		setSelected(isSelected);
	}

	private function mouseUp(event:MouseEvent):void {
		if (parent is CategorySelector) {
			CategorySelector(parent).select(categoryID);
		}
	}

}}
