// Shapes.as
// John Maloney, August 2009
//
// The Shapes class contains constant definitions that define the
// shapes and geometry used by Blocks and BlockArgs.

package Blocks {
	public class Shapes {

	static public var RectShape:Array = [
		["m", 0, 0], ["l", 6, 0], ["l", 6, 4], ["l", 0, 4]];

	static public var BooleanShape:Array = [
		["m", 2, 0],
		["l", 4, 0], ["l45", 6, 2], ["l45", 4, 4],
		["l", 2, 4], ["l45", 0, 2], ["l45", 2, 0]];

	static public var NumberShape:Array = [
		["m", 2, 0],
		["l", 4, 0], ["c45", 6, 2], ["c45", 4, 4],
		["l", 2, 4], ["c45", 0, 2], ["c45", 2, 0]];

	static public var CmdShape:Array = [
		["m", 0, 3], ["l", 3, 0],
		["l", 13, 0], ["l", 16, 3], ["l", 24, 3], ["l", 27, 0],
		["l", 37, 0], ["l", 40, 3], ["l", 40, 12], ["l", 37, 15],
		["l", 27, 15], ["l", 24, 18], ["l", 16, 18], ["l", 13, 15],
		["l", 3, 15], ["l", 0, 12]];

	static public var CmdNotchInset:int = 3;
 	static public var CmdHSplit:int = 30;

	static public var FinalCmdShape:Array = [
		["m", 0, 3], ["l", 3, 0],
		["l", 13, 0], ["l", 16, 3], ["l", 24, 3], ["l", 27, 0],
		["l", 57, 0], ["l", 60, 3], ["l", 60, 12], ["l", 57, 15],
		["l", 3, 15], ["l", 0, 12]];

	static public var HatShape:Array = [
		["m", 0, 12], ["c", 40, 0, 0.15], ["c", 80, 10, 0.12],
		["l", 97, 10], ["l", 100, 13], ["l", 100, 22], ["l", 97, 25],
		["l", 27, 25], ["l", 24, 28], ["l", 16, 28], ["l", 13, 25],
		["l", 3, 25], ["l", 0, 22]];

	static public var HatHSplit:int = 85;

	static public var LoopShape:Array = [
		["m", 0, 3], ["l", 3, 0],
		["l", 13, 0], ["l", 16, 3], ["l", 24, 3], ["l", 27, 0],
		["l", 57, 0], ["l", 60, 3], ["l", 60, 12], ["l", 57, 15],
		["l", 42, 15], ["l", 39, 18], ["l", 32, 18], ["l", 29, 15], 
		["l", 18, 15], ["l", 15, 18], ["l", 15, 27], ["l", 18, 30],
		["l", 57, 30], ["l", 60, 33], ["l", 60, 39], ["l", 57, 42],
		["l", 27, 42], ["l", 24, 45], ["l", 16, 45], ["l", 13, 42],
		["l", 3, 42], ["l", 0, 39]];

	static public var LoopHSplit:int = 45;
	static public var LoopSub1Split:int = 18;
	static public var LoopSub1OpeningH:int = 18;	// opening height in original shape
	static public var LoopEmptyOpening:int = 8;		// opening height for an empty C block

	static public var FinalLoopShape:Array = [
		["m", 0, 3], ["l", 3, 0],
		["l", 13, 0], ["l", 16, 3], ["l", 24, 3], ["l", 27, 0],
		["l", 57, 0], ["l", 60, 3], ["l", 60, 12], ["l", 57, 15],
		["l", 42, 15], ["l", 39, 18], ["l", 32, 18], ["l", 29, 15], 
		["l", 18, 15], ["l", 15, 18], ["l", 15, 27], ["l", 18, 30],
		["l", 57, 30], ["l", 60, 33], ["l", 60, 39], ["l", 57, 42],
		["l", 3, 42], ["l", 0, 39]];

}}
